#include <stdio.h>
#include <dos.h>

main( argc, argv )
int argc;
char *argv[];
{
	union REGS regs;
	int day, i;

	if ( argc < 3 ) {
		wrstratr ( "\\nusage: WEEKLY day message", 0x0f );
		wrstratr ( "\\n\\t where day is the name of the day of the week", 0x0f );
		wrstratr ( "\\n\\t and message is what is to be printed if the current", 0x0f );
		wrstratr ( "\\n\\t     day matches the day requested", 0x0f );
		wrstratr ( "\\n\\t message length max. to 40 characters", 0x0f );
		wrstratr ( "\\n\\t this program waits for a keystroke before terminating", 0x0f );
		wrstratr ( "\\n\\t     if the message is printed", 0x0f );
		wrstratr ( "\\n\\t primary usage is to provide a weekly reminder in a batch file", 0x0f );
		exit ( 1 );
	}

	if ( strlen( argv[1] ) < 3 ) {
		wrstratr ( "\\ntoo few characters to interpret day ", 0x0f );
		exit( 1 );
	}
	else if ( strlen( argv[2] ) > 40 ) {
		wrstratr ( "\\n message too long, max. 40 characters ", 0x0f );
		exit( 1 );
	}

	/* set up registers for finding date */
	regs.h.ah = 0x2a;
	day = intdos ( &regs, &regs );

	/* what day is it? */
	switch ( day & 0x00ff ) {
		case 0:			/* sunday */
			if ( strnicmp( argv[1], "sun", 3 ) )
				exit( 0 );
			break;
		case 1:			/* monday */
			if ( strnicmp( argv[1], "mon", 3 ) )
				exit( 0 );
			break;
		case 2:			/* tuesday */
			if ( strnicmp( argv[1], "tue", 3 ) )
				exit( 0 );
			break;
		case 3:			/* wednesday */
			if ( strnicmp( argv[1], "wed", 3 ) )
				exit( 0 );
			break;
		case 4:			/* thursday */
			if ( strnicmp( argv[1], "thu", 3 ) )
				exit( 0 );
			break;
		case 5:			/* friday */
			if ( strnicmp( argv[1], "fri", 3 ) )
				exit( 0 );
			break;
		case 6:			/* saturday */
			if ( strnicmp( argv[1], "sat", 3 ) )
				exit( 0 );
			break;
		default:
			exit( 1 );
	}/* end switch */

	/* assume if we got this far we have a match */
	/* print the message */
	for ( i=2; i<argc; i++ ) {
		wrstratr ( argv[i], 0xce );
		wrstratr ( " ", 0xce );
	}

	/* wait for keystroke */
	while ( !iskey() );
	getkey();
	exit( 0 );
}

/* writes a character and attribute on screen */
wrchatr( ch, attr )
unsigned char ch, attr;
{
	union REGS regs;

	regs.x.ax = 0x0900 | ( int )ch;
	regs.x.bx = 0x0000 | ( int )attr;
	regs.x.cx = 0x0001;

	int86( 0x10, &regs, &regs );
	return;
} /* end wrchatr */

/* write a string with attribute */
wrstratr( str, attr )
char *str;  /* string to print */
unsigned char attr;  /* attribute */
{
	static char row, col;

	getcurs( &row, &col );

	while ( *str ) {							/* while more string to print */
		if ( *str == '\\' ) {				/* special char */
			str++;								/* advance to next char */
			if ( *( str ) == 'n' ) {		/* newline char */
				if ( row >= 24 )
					scroll ( 0, 0, 24, 79, 1, attr, 0 );	/* scroll up */
				else
					row++;
				col=-1;
				str++;
			}
			else if ( *str == 't' ) {		/* tab char */
				col += 8;
				str++;
			}
			else {								/* not recognized, print slash & char */
				wrchatr ( '\\', attr );
				setcurs ( row, ++col );
				wrchatr ( *str++, attr );
			}
		}
		else
			wrchatr( *str++, attr );

		setcurs( row, ++col );
	}
	return;
}

/* position cursor on screen */
setcurs( row, col )
char row, col;
{
	union REGS regs;

	regs.x.ax = 0x0200;
	regs.x.bx = 0x0000;
	regs.x.dx = row << 8;
	regs.x.dx |= col;

	int86( 0x10, &regs, &regs );
	return;
} /* end setcurs */

/* read cursor position */
getcurs( row, col )
char *row, *col;
{
	union REGS regs;

	regs.x.ax = 0x0300;
	regs.x.bx = 0x0000;

	int86( 0x10, &regs, &regs );

	*col = regs.x.dx;
	*row = regs.x.dx >> 8;
	return;
} /* end getcurs */

/* scroll window */
scroll ( ulrow, ulcol, lrrow, lrcol, numlines, attr, updown )
char ulrow, ulcol, lrrow, lrcol;		/* corners of window */
int numlines;								/* how many lines to scroll */
char attr;									/* fill attribute to use */
int updown;									/* 0=up, 1 = down */
{
	union REGS regs;

	regs.h.ah = 6+(char)updown;		/* set service */
	regs.h.al = (char)numlines;		/* set number of lines to scroll */
	regs.h.bh = attr;						/* set video fill attribute */
	regs.h.ch = (char)ulrow;			/* set borders */
	regs.h.cl = (char)ulcol;			/* set borders */
	regs.h.dh = (char)lrrow;			/* set borders */
	regs.h.dl = (char)lrcol;			/* set borders */

	int86( 0x10, &regs, &regs );
}

/*********************************/
/*	iskey()								*/
/*		return whether key waiting	*/
/*********************************/
iskey()
{
	union REGS regs;

	regs.x.ax = 0x0100;
	int86( 0x16, &regs, &regs );

	return( !( 0x0040 & regs.x.flags ) );
} /* end iskey */

/************************************************/
/*	getkey()													*/
/*		return keyboard character and scan code	*/
/************************************************/
getkey()
{
	union REGS regs;

	regs.x.ax = 0x0000;

	int86( 0x16, &regs, &regs );
	return( regs.x.ax );
} /* end getkey */
